import processing.core.*; 
import processing.xml.*; 

import processing.video.*; 
import seltar.motion.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class microbeMania extends PApplet {




Capture video;
Spaceship s; 
Mothership ms;
int qx = 10;
int dx = 5;
int fx = 1;
PFont font;
boolean kp = false;
int inst = 0;
int x = 0;
int timer = 0;
float ranX = 320;
float ranY = 240;
float rx = 320;
float ry = 240;
float brx = 320;
float bry = 240;

public void setup() {
  size(640,480);
  video = new Capture(this,width,height,30);
  noStroke();
  smooth();
  font = loadFont("SynchroLET-48.vlw");
  textFont(font);
  frameRate(10);
  s = new Spaceship(rx,ry);
}

public void draw() {
  if (kp == false) {
    background((loadImage("background.jpg")));
    fill(255);
    textSize(20);
    text("You have been working all year on", 0, 40);
    text("a new chemical sample. However, something", 0, 60);
    text("has been destroying your work.", 0, 80);
    text("Use your light source, the white circle,", 0, 160);
    text("and find out what is happening.", 0, 180);
    text("Press 'a' To Abort While In Game", 150, 440);
    text("Press 's' To Start The Game", 180, 460);
    if ((keyPressed == true) && (key == 's')) {
      kp = true;
      qx = 10;
      dx = 5;
    }
  } else if (kp == true) {
    if (video.available()) {
      video.read();
      image(video, 0, 0, width, height);
      int bx = 0;
      int by = 0;
      float brightestValue = 0;
      background(loadImage("background1.jpg"));
      video.loadPixels();
      int index = 0;
      for (int y = 0; y < video.height; y++) {
        for (int x = 0; x < video.width; x++) {
          int pixelValue = video.pixels[index];
          float pixelBrightness = brightness(pixelValue);
          if (pixelBrightness > brightestValue) {
            brightestValue = pixelBrightness;
           by = y;
            bx = 640-x;
          }
          index++;
        }
      }
      
      if ((keyPressed == true) && (key == 'a')) {
        kp = false;
      }
      
      fill(255);
      ellipse(bx, by, 10, 10);
      
      for (int ix = 0; ix < qx; ix++) {
        if (timer == 1) {
          rx = random(640);
          ry = random(480);
          s = new Spaceship(rx,ry);
        } else if (timer == 25) {
          timer = 0;
        }
        
        if ((bx >= (rx - 25)) && (bx <= (rx + 25)) && 
        (by >= (ry - 25)) && (by <= (ry + 25))) {
          image(loadImage("boom.png"),rx,ry);
          qx--;
        } else {
          s.display();
        }
      } 
        
      if (qx == 0) {
          if (timer == 1) {
            brx = random(640);
            bry = random(480);
          } else if (timer == 25) {
            timer = 0;
          }
          
          ms = new Mothership(brx,bry);
          
        if ((bx >= (brx - 50)) && (bx <= (brx + 50)) && 
           (by >= (bry - 50)) && (by <= (bry + 50))) {
           image(loadImage("boom.png"),rx,ry);
           dx--;
        } else {
           ms.display();
        }
        if (dx == 0) {
          background(255,0,0);
          fill(255);
          textSize(50);
          text("OH NO!", 300, 230);
          qx = 10;
        }
      }
      imageMode(CORNER);
      image(loadImage("foreground.png"),0,0); 
      fill(200,200,200);
      textSize(100);
      if (qx > 0) {
        text(qx, 500, 450);
      } else {
        text(dx, 500, 450);
      }
      timer++;
    }
  }
}

class Mothership
{
  Motion m;
  Mothership(float X, float Y)
  {
    m = new Motion(X,Y);  
  }
    
  
  public void move()
  {
    if (timer == 1) {
      ranX = random(640);
      ranY = random(480);
    } else if (timer == 25) {
      timer = 0;
    }
  
    m.followTo(ranX, ranY);
    m.wrap(0,0,width,height);
    m.move();
    

  }
  
  public void display()
  {
    move();
    imageMode(CENTER);
    image(loadImage("boss2.png"),m.getX(),m.getY());    
    strokeWeight(1);
    drawVector(20);
  }
  
  public void drawVector(float scayl) {
    stroke(200);
    float arrowsize = 7;
    
    pushMatrix();
      translate(m.getX(),m.getY());
      rotate(m.v.getDirection() - PI);
      float len = m.v.getVelocity()*scayl;
    
      line(0,0,len,0);
      line(len,0,len-arrowsize,+arrowsize/2);
      line(len,0,len-arrowsize,-arrowsize/2);
    popMatrix();
  }
}

class Spaceship
{
  Motion m;
  Spaceship(float X, float Y)
  {
    m = new Motion(X,Y);  
  }
    
  
  public void move()
  {
    if (timer == 1) {
      ranX = random(640);
      ranY = random(480);
    } else if (timer == 25) {
      timer = 0;
    }
  
    m.followTo(ranX, ranY);
    m.wrap(0,0,width,height);
    m.move();
    

  }
  
  public void display()
  {
    move();
    imageMode(CENTER);
    image(loadImage("sprite1.png"),m.getX(),m.getY());  
    strokeWeight(1);
    drawVector(20);
  }
  
  public void drawVector(float scayl) {
    stroke(200);
    float arrowsize = 7;
    
    pushMatrix();
      translate(m.getX(),m.getY());
      rotate(m.v.getDirection() - PI);
      float len = m.v.getVelocity()*scayl;
    
      line(0,0,len,0);
      line(len,0,len-arrowsize,+arrowsize/2);
      line(len,0,len-arrowsize,-arrowsize/2);
    popMatrix();
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "microbeMania" });
  }
}
